// replacement for <dirent.h> that is portable to Windoze

#ifdef WIN32

#ifndef _DIRENT_H_
#define _DIRENT_H_

// this structure is subject to change!
typedef struct dirent {
  char d_name[1];
} dirent;

int numericsort(struct dirent **, struct dirent **);

extern int scandir(const char *dirname, struct dirent **namelist[],
     int (*select)(struct dirent *),
     int (*compar)(struct dirent **, struct dirent **));

#define MAX_PATH 260 // from <windef.h>

#endif

#else

#include <sys/types.h>
#include <dirent.h>
extern "C" {
int numericsort(struct dirent **, struct dirent **);
#ifdef SVR4
int scandir (const char *dir, struct dirent ***namelist,
	     int (*select)(struct dirent *),
	     int (*compar)(struct dirent **, struct dirent **));
#endif
}

#endif


